# excel2chatgpt

##### 📑 EXCEL <=>  ChatGPT 🤖


Fill a column of an EXCEL file using another column as a [ChatGPT](https://openai.com/blog/chatgpt/) prompt.

🛟 Find help in [Telegram](https://t.me/+TuRPrGt5zZoyZjlh)

## Install

Requirements: [nodejs](https://nodejs.org/) >=18 (Latest [maintenance LTS](https://github.com/nodejs/Release#release-schedule) version),
 [npm](https://www.npmjs.com/), [chrome/chromium](https://www.chromium.org/chromium-projects/) and [OpenAI credentials](https://openai.com/blog/chatgpt/)

```bash
$ npm install
```

## Configuration

Edit `.env` file

Free mode is limited to 5 iterations. 
Unlock this limitation by purchasing 
a license at https://jordifernandes.com/excel2chatgpt
```javascript
LICENSE="free"
```

OpenAi credentials:
```javascript
OPENAI_EMAIL="your@mail.com"
OPENAI_PASSWORD="yourpassword"
```

Input/Output of XLSX file:
```javascript
INPUT="./example.xlsx"
OUTPUT="./example.xlsx"
```

Global concatenation before and after prompt:
```javascript
PROMPT_PREFIX="Describe in 15 words:"
PROMPT_SUFFIX=""
```

First row of the XLSX where a read begins:
```javascript
FIRST_ROW=2
```

Prompt Cell position in XLSX file:
```javascript
PROMPT_CELL=1
```

Result Cell position in XLSX file:
```javascript
RESULT_CELL=2
```

`1` for overwrite result column, `0` for ignore a not empty cells:
```javascript
OVERWRITE_RESULT_CELL=1
```

Milliseconds to wait between each iteration
use "AUTO" for random values between 10000 and 60000 ms
(chatGPT may limit for excessive requests with a 429 error):
```javascript
ITERATION_TIME_SLEEP=15000
```

Milliseconds to wait if ChatGPT return error "too many requests"
(default 1 hour):
```javascript
TOO_MANY_REQUESTS_TIME_SLEEP=3600000
```
##### Example
![Screeshot](doc/4.png?raw=true "Screeshot")


## Run

##### 1. Run
```bash
$ npm run start
```
##### 2. Solve the Captcha
![Screeshot](doc/1.png?raw=true "Screeshot")

##### 3. Working
![Screeshot](doc/2.png?raw=true "Screeshot")

##### 4. Result
![Screeshot](doc/3.png?raw=true "Screeshot")

## Authors

- [Jordi Fernandes (@jfadev)](https://github.com/jfadev)